<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="设备名称" prop="deviceName">
        <el-input
          v-model="queryParams.deviceName"
          placeholder="请输入设备名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="上报时间" prop="reportTime">
        <el-date-picker
          v-model="queryParams.value1"
          value-format="yyyy-MM-dd HH:mm:ss"
          type="datetimerange"
          range-separator="至"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
          @change="dateFormat">
        </el-date-picker>
        <!--<el-date-picker clearable size="small"-->
          <!--v-model="queryParams.reportTime"-->
          <!--type="date"-->
          <!--value-format="yyyy-MM-dd"-->
          <!--placeholder="选择上报时间">-->
        <!--</el-date-picker>-->
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="inList" @selection-change="handleSelectionChange">
      <!--<el-table-column type="selection" width="55" align="center" />-->
      <!--<el-table-column label="签到id" align="center" prop="checkInId" />-->
      <el-table-column label="设备名称" align="center" prop="deviceName" />
      <el-table-column label="照片地址" align="center" prop="photoUrl" >
        <template slot-scope="scope">
          <el-image :src="scope.row.photoUrl" :preview-src-list="[scope.row.photoUrl]" :z-index="9999" style="width: 30px;height: 30px;"></el-image>
        </template>
      </el-table-column>
      <el-table-column label="描述" align="center" prop="patrolDescribe" />
      <el-table-column label="上报时间" align="center" prop="reportTime" width="180">
        <!--<template slot-scope="scope">-->
          <!--<span>{{ parseTime(scope.row.reportTime, '{y}-{m}-{d}') }}</span>-->
        <!--</template>-->
      </el-table-column>
      <el-table-column label="上报人" align="center" prop="personName" />
      <!--<el-table-column label="经度" align="center" prop="longitude" />-->
      <!--<el-table-column label="纬度" align="center" prop="latitude" />-->
      <!--<el-table-column label="备注" align="center" prop="remark" />-->
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
          >详情</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改巡检签到对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="1000px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="90px">
        <div class="showOne">
          <div style="width: 55%">
            <el-form-item label="设备名称：" prop="deviceName">
              <div class="content">{{form.deviceName}}</div>
            </el-form-item>
            <el-form-item label="签到照片：" prop="photoUrl">
              <el-image :src="form.photoUrl" :preview-src-list="[form.photoUrl]" :z-index="9999" style="width: 80px;height: 100px;"></el-image>
            </el-form-item>

            <el-form-item label="描述：" prop="patrolDescribe">
              <div class="content">{{form.patrolDescribe}}</div>
              <!--<el-input v-model="form.patrolDescribe" type="textarea" placeholder="请输入内容" style="border: 0" disabled/>-->
            </el-form-item>
            <el-form-item label="上报时间：" prop="reportTime">
              <div class="content">{{form.reportTime}}</div>
            </el-form-item>
            <el-form-item label="上报人：" prop="reportPerson">
              <div class="content">{{form.reportPerson}}</div>
            </el-form-item>
            <el-form-item label="备注：" prop="remark">
              <div class="content">{{form.remark}}</div>
            </el-form-item>
          </div>
          <div style="width: 45%;height: 400px" id="troubleContainer"></div>
        </div>


        <!--<el-form-item label="经度" prop="longitude">-->
          <!--<el-input v-model="form.longitude" placeholder="请输入经度" />-->
        <!--</el-form-item>-->
        <!--<el-form-item label="纬度" prop="latitude">-->
          <!--<el-input v-model="form.latitude" placeholder="请输入纬度" />-->
        <!--</el-form-item>-->

      </el-form>
      <!--<div slot="footer" class="dialog-footer">-->
        <!--<el-button type="primary" @click="submitForm">确 定</el-button>-->
        <!--<el-button @click="cancel">取 消</el-button>-->
      <!--</div>-->
    </el-dialog>
  </div>
</template>

<script>
import { listIn, getIn, delIn, addIn, updateIn, exportIn } from "@/api/system/in";
import GetPos from '@/components/GetPos';
import { EditorMap } from "@/utils/mapClass/getPath.js";
export default {
  name: "In",
  components: {
    GetPos
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      map: null,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 巡检签到表格数据
      inList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        deviceName: null,
        photoUrl: null,
        patrolDescribe: null,
        reportTime: null,
        reportPerson: null,
        longitude: null,
        latitude: null,
        value1:[]
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  onload(){

  },
  methods: {
    /** 查询巡检签到列表 */
    getList() {
      console.log(this.queryParams)
      this.loading = true;
      listIn(this.queryParams).then(response => {
        this.inList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        checkInId: null,
        deviceName: null,
        photoUrl: null,
        patrolDescribe: null,
        reportTime: null,
        reportPerson: null,
        longitude: null,
        latitude: null,
        isDel: null,
        remark: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
      this.value1 = [];
      this.queryParams.reportTimeBegin = null;
      this.queryParams.reportTimeEnd = null;
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.checkInId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加巡检签到";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const checkInId = row.checkInId || this.ids
      getIn(checkInId).then(response => {
        this.form = response.data;
        this.form.reportPerson = row.personName;
        this.open = true;
        this.title = "巡检签到详情";
        this.devicePos = [row.longitude, row.latitude];
        console.log(this.devicePos)
        this.$nextTick(() => {
          this.map = new EditorMap("troubleContainer", {}, this);
          this.map.addDevice({ path: this.devicePos });
          this.map.nowMouseTarget = null;
          this.map.mousetoolClose(false);
        });
      });

    },
    /** 提交按钮 */
    submitForm(){
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.checkInId != null) {
            updateIn(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addIn(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const checkInIds = row.checkInId || this.ids;
      this.$confirm('是否确认删除巡检签到编号为"' + checkInIds + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delIn(checkInIds);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有巡检签到数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportIn(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    dateFormat(picker){
      console.log(picker)
      this.reportTime = picker;
      this.queryParams.reportTimeBegin = picker[0];
      this.queryParams.reportTimeEnd = picker[1];
    },
  }
};
</script>
<style>
  .showOne {
    display:flex;
    flex-direction:row;
    justify-content:flex-start;
  }
  .content{
    padding-top: 1px;
  }
</style>
<style lang="scss" scoped>
  ::v-deep .el-textarea__inner {
    border: 0;
    padding-top: 8px;
  }
  ::v-deep .el-transfer__button:first-child {
    margin-bottom: 10px;
  }
</style>
